// generated from file '../src/faust/expander.dsp' by dsp2cc:
// Code generated with Faust 0.9.46 (http://faust.grame.fr)


namespace expander {

class Dsp: public PluginDef {
private:
	int fSamplingFreq;
	FAUSTFLOAT 	fentry0;
	FAUSTFLOAT 	fentry1;
	int 	iConst0;
	double 	fConst1;
	FAUSTFLOAT 	fslider0;
	double 	fConst2;
	double 	fConst3;
	double 	fRec1[2];
	FAUSTFLOAT 	fslider1;
	double 	fRec0[2];
	double 	fRec2[2];
	FAUSTFLOAT 	fentry2;
	double 	fRec3[2];
	void clear_state_f();
	void init(unsigned int samplingFreq);
	void compute(int count, float *input0, float *output0);
	int register_par(const ParamReg& reg);

	static void clear_state_f_static(PluginDef*);
	static void init_static(unsigned int samplingFreq, PluginDef*);
	static void compute_static(int count, float *input0, float *output0, PluginDef*);
	static int register_params_static(const ParamReg& reg);
	static void del_instance(PluginDef *p);

public:
	Dsp();
	~Dsp();
};



Dsp::Dsp()
	: PluginDef() {
	version = PLUGINDEF_VERSION;
	flags = 0;
	id = "expander";
	name = N_("Expander");
	groups = 0;
	description = N_("expander unit"); // description (tooltip)
	category = N_("Guitar Effects");       // category
	shortname = "";     // shortname
	mono_audio = compute_static;
	stereo_audio = 0;
	set_samplerate = init_static;
	activate_plugin = 0;
	register_params = register_params_static;
	load_ui = 0;
	clear_state = clear_state_f_static;
	delete_instance = del_instance;
}

Dsp::~Dsp() {
}

inline void Dsp::clear_state_f()
{
	for (int i=0; i<2; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec0[i] = 0;
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<2; i++) fRec3[i] = 0;
}

void Dsp::clear_state_f_static(PluginDef *p)
{
	static_cast<Dsp*>(p)->clear_state_f();
}

inline void Dsp::init(unsigned int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	iConst0 = min(192000, max(1, fSamplingFreq));
	fConst1 = (1.0 / iConst0);
	fConst2 = exp((0 - (1e+01 / iConst0)));
	fConst3 = (1 - fConst2);
	clear_state_f();
}

void Dsp::init_static(unsigned int samplingFreq, PluginDef *p)
{
	static_cast<Dsp*>(p)->init(samplingFreq);
}

inline void Dsp::compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fentry1;
	double 	fSlow1 = (fentry0 + fSlow0);
	double 	fSlow2 = exp((0 - (fConst1 / max(fConst1, fslider0))));
	double 	fSlow3 = exp((0 - (fConst1 / max(fConst1, fslider1))));
	double 	fSlow4 = (1.0 / (0.001 + fSlow0));
	double 	fSlow5 = fentry2;
	for (int i=0; i<count; i++) {
		double fTemp0 = (double)input0[i];
		fRec1[0] = ((fConst2 * fRec1[1]) + (fConst3 * fabs(fTemp0)));
		double fTemp1 = max(fRec1[0], fTemp0);
		double fTemp2 = ((fSlow2 * (fRec0[1] < fTemp1)) + (fSlow3 * (fRec0[1] >= fTemp1)));
		fRec0[0] = ((fRec0[1] * fTemp2) + (fTemp1 * (1 - fTemp2)));
		double fTemp3 = ((fSlow2 * (fRec2[1] < fTemp1)) + (fSlow3 * (fRec2[1] >= fTemp1)));
		fRec2[0] = ((fRec2[1] * fTemp3) + (fTemp1 * (1 - fTemp3)));
		double fTemp4 = ((fSlow2 * (fRec3[1] < fTemp1)) + (fSlow3 * (fRec3[1] >= fTemp1)));
		fRec3[0] = ((fRec3[1] * fTemp4) + (fTemp1 * (1 - fTemp4)));
		output0[i] = (FAUSTFLOAT)(fTemp0 * pow(10,(0.05 * (max(0, (fSlow1 - (20 * log10(fRec0[0])))) * (min(1, max(0, (fSlow4 * max(0, (fSlow1 - (20 * log10(fRec2[0]))))))) - (fSlow5 * min(1, max(0, (fSlow4 * max(0, (fSlow1 - (20 * log10(fRec3[0])))))))))))));
		// post processing
		fRec3[1] = fRec3[0];
		fRec2[1] = fRec2[0];
		fRec0[1] = fRec0[0];
		fRec1[1] = fRec1[0];
	}
}

void Dsp::compute_static(int count, float *input0, float *output0, PluginDef *p)
{
	static_cast<Dsp*>(p)->compute(count, input0, output0);
}

int Dsp::register_par(const ParamReg& reg)
{
	reg.registerVar("expander.ratio","","S","",&fentry2, 2.0, 1.0, 2e+01, 0.1);
	reg.registerVar("expander.knee","","S","",&fentry1, 3.0, 0.0, 2e+01, 0.1);
	reg.registerVar("expander.threshold","","S","",&fentry0, -4e+01, -96.0, 1e+01, 0.1);
	reg.registerVar("expander.release","","S","",&fslider1, 0.1, 0.0, 1e+01, 0.01);
	reg.registerVar("expander.attack","","S","",&fslider0, 0.001, 0.0, 1.0, 0.001);
	return 0;
}

int Dsp::register_params_static(const ParamReg& reg)
{
	return static_cast<Dsp*>(reg.plugin)->register_par(reg);
}

PluginDef *plugin() {
	return new Dsp();
}

void Dsp::del_instance(PluginDef *p)
{
	delete static_cast<Dsp*>(p);
}

} // end namespace expander
