// generated from file '../src/faust/stereodelay.dsp' by dsp2cc:
// Code generated with Faust 0.9.46 (http://faust.grame.fr)


namespace stereodelay {

class Dsp: public PluginDef {
private:
	int fSamplingFreq;
	int 	IOTA;
	float *fVec0;
	int 	iVec1[2];
	FAUSTFLOAT 	fslider0;
	float 	fRec0[2];
	FAUSTFLOAT 	fcheckbox0;
	int 	iConst0;
	float 	fConst1;
	FAUSTFLOAT 	fslider1;
	float 	fRec1[2];
	float 	fRec2[2];
	float 	fConst2;
	FAUSTFLOAT 	fslider2;
	float *fVec2;
	FAUSTFLOAT 	fslider3;
	float 	fRec3[2];
	FAUSTFLOAT 	fslider4;
	bool mem_allocated;
	void mem_alloc();
	void mem_free();
	void clear_state_f();
	int activate(bool start);
	void init(unsigned int samplingFreq);
	void compute(int count, float *input0, float *input1, float *output0, float *output1);
	int register_par(const ParamReg& reg);

	static void clear_state_f_static(PluginDef*);
	static int activate_static(bool start, PluginDef*);
	static void init_static(unsigned int samplingFreq, PluginDef*);
	static void compute_static(int count, float *input0, float *input1, float *output0, float *output1, PluginDef*);
	static int register_params_static(const ParamReg& reg);
	static void del_instance(PluginDef *p);

public:
	Dsp();
	~Dsp();
};



Dsp::Dsp()
	: PluginDef(),
	  fVec0(0),
	  fVec2(0),
	  mem_allocated(false) {
	version = PLUGINDEF_VERSION;
	flags = 0;
	id = "stereodelay";
	name = N_("Stereo Delay");
	groups = 0;
	description = ""; // description (tooltip)
	category = N_("Echo / Delay");       // category
	shortname = "";     // shortname
	mono_audio = 0;
	stereo_audio = compute_static;
	set_samplerate = init_static;
	activate_plugin = activate_static;
	register_params = register_params_static;
	load_ui = 0;
	clear_state = clear_state_f_static;
	delete_instance = del_instance;
}

Dsp::~Dsp() {
}

inline void Dsp::clear_state_f()
{
	for (int i=0; i<262144; i++) fVec0[i] = 0;
	for (int i=0; i<2; i++) iVec1[i] = 0;
	for (int i=0; i<2; i++) fRec0[i] = 0;
	for (int i=0; i<2; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<262144; i++) fVec2[i] = 0;
	for (int i=0; i<2; i++) fRec3[i] = 0;
}

void Dsp::clear_state_f_static(PluginDef *p)
{
	static_cast<Dsp*>(p)->clear_state_f();
}

inline void Dsp::init(unsigned int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	IOTA = 0;
	iConst0 = min(192000, max(1, fSamplingFreq));
	fConst1 = (6.283185307179586f / iConst0);
	fConst2 = (0.001f * iConst0);
}

void Dsp::init_static(unsigned int samplingFreq, PluginDef *p)
{
	static_cast<Dsp*>(p)->init(samplingFreq);
}

void Dsp::mem_alloc()
{
	if (!fVec0) fVec0 = new float[262144];
	if (!fVec2) fVec2 = new float[262144];
	mem_allocated = true;
}

void Dsp::mem_free()
{
	mem_allocated = false;
	if (fVec0) { delete fVec0; fVec0 = 0; }
	if (fVec2) { delete fVec2; fVec2 = 0; }
}

int Dsp::activate(bool start)
{
	if (start) {
		if (!mem_allocated) {
			mem_alloc();
			clear_state_f();
		}
	} else if (!mem_allocated) {
		mem_free();
	}
	return 0;
}

int Dsp::activate_static(bool start, PluginDef *p)
{
	return static_cast<Dsp*>(p)->activate(start);
}

inline void Dsp::compute(int count, float *input0, float *input1, float *output0, float *output1)
{
	float 	fSlow0 = (0.0010000000000000009f * powf(10,(0.05f * fslider0)));
	float 	fSlow1 = fcheckbox0;
	float 	fSlow2 = (fConst1 * fslider1);
	float 	fSlow3 = sinf(fSlow2);
	float 	fSlow4 = cosf(fSlow2);
	float 	fSlow5 = (0 - fSlow3);
	float 	fSlow6 = (fConst2 * fslider2);
	int 	iSlow7 = int(fSlow6);
	int 	iSlow8 = (1 + iSlow7);
	float 	fSlow9 = (iSlow8 - fSlow6);
	int 	iSlow10 = int((iSlow7 & 262143));
	float 	fSlow11 = (fSlow6 - iSlow7);
	int 	iSlow12 = int((int(iSlow8) & 262143));
	float 	fSlow13 = (0.0010000000000000009f * powf(10,(0.05f * fslider3)));
	float 	fSlow14 = (fConst2 * fslider4);
	int 	iSlow15 = int(fSlow14);
	int 	iSlow16 = (1 + iSlow15);
	float 	fSlow17 = (iSlow16 - fSlow14);
	int 	iSlow18 = int((iSlow15 & 262143));
	float 	fSlow19 = (fSlow14 - iSlow15);
	int 	iSlow20 = int((int(iSlow16) & 262143));
	for (int i=0; i<count; i++) {
		float fTemp0 = (float)input0[i];
		fVec0[IOTA&262143] = fTemp0;
		iVec1[0] = 1;
		fRec0[0] = ((0.999f * fRec0[1]) + fSlow0);
		fRec1[0] = ((fSlow3 * fRec2[1]) + (fSlow4 * fRec1[1]));
		fRec2[0] = ((1 + ((fSlow4 * fRec2[1]) + (fSlow5 * fRec1[1]))) - iVec1[1]);
		float fTemp1 = (fSlow1 * fRec1[0]);
		output0[i] = (FAUSTFLOAT)(fVec0[IOTA&262143] + ((fRec0[0] * (1 + fTemp1)) * ((fSlow9 * fVec0[(IOTA-iSlow10)&262143]) + (fSlow11 * fVec0[(IOTA-iSlow12)&262143]))));
		float fTemp2 = (float)input1[i];
		fVec2[IOTA&262143] = fTemp2;
		fRec3[0] = ((0.999f * fRec3[1]) + fSlow13);
		output1[i] = (FAUSTFLOAT)(fVec2[IOTA&262143] + ((fRec3[0] * (1 - fTemp1)) * ((fSlow17 * fVec2[(IOTA-iSlow18)&262143]) + (fSlow19 * fVec2[(IOTA-iSlow20)&262143]))));
		// post processing
		fRec3[1] = fRec3[0];
		fRec2[1] = fRec2[0];
		fRec1[1] = fRec1[0];
		fRec0[1] = fRec0[0];
		iVec1[1] = iVec1[0];
		IOTA = IOTA+1;
	}
}

void Dsp::compute_static(int count, float *input0, float *input1, float *output0, float *output1, PluginDef *p)
{
	static_cast<Dsp*>(p)->compute(count, input0, input1, output0, output1);
}

int Dsp::register_par(const ParamReg& reg)
{
	static const value_pair fcheckbox0_values[] = {{"linear"},{"pingpong"},{0}};
	reg.registerEnumVar("stereodelay.invert","","B","",fcheckbox0_values,&fcheckbox0, 0.0, 0.0, 1.0, 1.0);
	reg.registerVar("stereodelay.r_delay","","S","",&fslider4, 0.0f, 0.0f, 5e+03f, 1e+01f);
	reg.registerVar("stereodelay.r_gain","","S","",&fslider3, 0.0f, -2e+01f, 2e+01f, 0.1f);
	reg.registerVar("stereodelay.l_delay","","S","",&fslider2, 0.0f, 0.0f, 5e+03f, 1e+01f);
	reg.registerVar("stereodelay.LFO freq","","S","",&fslider1, 0.2f, 0.0f, 5.0f, 0.01f);
	reg.registerVar("stereodelay.l_gain","","S","",&fslider0, 0.0f, -2e+01f, 2e+01f, 0.1f);
	return 0;
}

int Dsp::register_params_static(const ParamReg& reg)
{
	return static_cast<Dsp*>(reg.plugin)->register_par(reg);
}

PluginDef *plugin() {
	return new Dsp();
}

void Dsp::del_instance(PluginDef *p)
{
	delete static_cast<Dsp*>(p);
}

} // end namespace stereodelay
